/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * CIRCLE.H
 *
 * PROGRAMMER : Juan M. Alvarado
 *    VERSION : 00.000
 *    CREATED : 03/06/92
 *   MODIFIED : 07/30/92
 *       TABS : 04 08
 *
 * DESCRIPTION
 *		Circle drawing externs and macros.
 *
 * HISTORY
 *
*/

#ifndef ECHIDNA_CIRCLE_H
#define ECHIDNA_CIRCLE_H

#include <echidna/platform.h>
#include "switches.h"

#ifdef __cplusplus
extern "C" {
#endif

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/

#define DiameterFromRadius(r)	(2*(r) + 1)
#define RadiusFromDiameter(d)	((d) / 2)

/* DrawCircleQ3 means Draw circle in quadrant 3, or in other words I'm
 * giving you coordinates of upper left 'corner' of circle
 */
#define DrawCircleQ3(x,y,r)						\
	DrawCircle ((x) + (r),		\
		(y) + (r),				\
		(r))

#define DrawFCircleQ3(x,y,r)						\
	DrawFCircle ((x) + (r),		\
		(y) + (r),				\
		(r))

/****************** F U N C T I O N   P R O T O T Y P E S *****************/



extern void				 DrawCircle (short x, short y, short radius);
extern void				 DrawFCircle (short x, short y, short radius);

#ifdef __cplusplus
}
#endif

#endif /* CIRCLE_H */

