/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * EMACROS.h
 *
 * PROGRAMMER : Gregg A. Tavares cp 
 *    VERSION : 00.000
 *    CREATED : 08/01/89 
 *   MODIFIED : 07/26/94
 *       TABS : 05 09
 *
 * DESCRIPTION
 *   various useful macros and defines
 *
 * HISTORY
 *
*/
#ifndef ECHIDNA_EMACROS_H
#define ECHIDNA_EMACROS_H

#include <echidna/platform.h>
#include "switches.h"

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/etypes.h>

#ifndef OKAY
#define OKAY		1
#endif

#ifndef NULL
#define NULL		0L
#endif

#ifndef FALSE
#define FALSE		0L
#endif

#ifndef TRUE
#define TRUE		(!FALSE)
#endif

#ifndef abs
#define	abs(value)	(((value) < 0) ? -(value) : (value))
#endif

#ifndef min
#define	min(a,b)	(((a) < (b)) ? (a) : (b))
#endif

#ifndef max
#define	max(a,b)	(((a) > (b)) ? (a) : (b))
#endif

#ifndef sign
#define sign(value)	(((value) > 0) - ((value) < 0))
#endif

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_EMACROS_H */

