/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * GRAFX.H
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 09/11/90
 *   MODIFIED : 02/05/95
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Non game graphics routines.
 *
 * HISTORY
 *		09/27/93 Monday (dcc) - updated for MS-DOS Watcom C.
 *
*/

#ifndef ECHIDNA_GRAFX_H
#define ECHIDNA_GRAFX_H

#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#define USE_GRAFX	1

#include <echidna/etypes.h>

#include <echidna/bytemap.h>
#include <echidna/graphics.h>
#include <echidna/dbuf.h>

/**************************** C O N S T A N T S ***************************/

#undef BeforeGraphics
#undef AfterGraphics
#define BeforeGraphics	RealBeforeGraphics
#define AfterGraphics	RealAfterGraphics

/******************************** T Y P E S *******************************/

typedef void (*VoidFunc)(void);

/****************************** G L O B A L S *****************************/

extern UBYTE RemapTable[256];

extern VoidFunc	BeforeGraphicsFunc;
extern VoidFunc	AfterGraphicsFunc;

/******************************* M A C R O S ******************************/

#define SetClipValues(x,y,w,h)	SetClipDimensions((x),(y),(w),(h))

/*
** The Following macros are used because these routines have not
** been implemented yet.
*/

#define	DrawPatRect	DrawRect
#define	DrawXorRect	XORRect
#define	DrawPatXorRect(x,y,w,h)		{int z; z=x+y+w+h; z=z;}	/* CODE DOES NOTHING, SILENCES COMPILER */
#define	SetRectPat(n)

/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern BOOL			 PushClipValues (int x, int y, int w, int h);
extern BOOL			 ClipPushClipValues (int x, int y, int w, int h);
extern void			 PopClipValues (void);
extern void			 PopSaveArea (void);
extern BOOL			 PushSaveArea (int x, int y, int w, int h);

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_GRAFX_H */

