/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * rgmextra.h
 *
 * PROGRAMMER : Richard G. Marquez
 *    VERSION : 00.000
 *    CREATED : 12/20/89
 *   MODIFIED : 11/01/93
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Extra misc. frequently used stuff.
 *
 * HISTORY
 *	12/20/89 Wednesday - Created. (RGM)
 *
*/

#ifndef ECHIDNA_RGMEXTRA_H
#define ECHIDNA_RGMEXTRA_H

#include <echidna/platform.h>
#include "switches.h"

#ifdef __cplusplus
extern "C" {
#endif

/**************************** C O N S T A N T S ***************************/
#if __AMIGAOS__

#define IN_TEXT			"r"
#define OUT_TEXT		"w"
#define APPEND_TEXT		"a"
#define IN_BINARY		"r"
#define OUT_BINARY		"w"
#define APPEND_BINARY	"a"

#else

#define IN_TEXT			"r"
#define OUT_TEXT		"w"
#define APPEND_TEXT		"a"
#define IN_BINARY		"rb"
#define OUT_BINARY		"wb"
#define APPEND_BINARY	"ab"

#endif /* __AMIGAOS__ */
/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/

#define	SAFEFREE(ptr)	if (ptr) free (ptr)

/****************** F U N C T I O N   P R O T O T Y P E S *****************/
#if __NOT_ANSI__		/** Non-ANSI Prototypes **/
#else					/** ANSI Prototypes **/
#endif /** Function Prototypes **/

#ifdef __cplusplus
}
#endif

#endif /* ECHIDNA_RGMEXTRA_H */

