/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * TIMER.H
 *
 * PROGRAMMER : Dan Chang
 *    VERSION : 00.000
 *    CREATED : 05/21/91
 *   MODIFIED : 10/26/94
 *       TABS : 04 08
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *		06/01/91 Saturday (RGM) - Added Amiga/SAS/Lattice compatable
 *									'InterruptRoutineType'.
 *		09/13/93 Monday (dcc) - MS-DOS protected-mode support added.
 *
*/

#ifndef TIMER_H
#define TIMER_H
#include <echidna/platform.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <echidna/etypes.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/

#if LATTICE
typedef void __far __saveds InterruptRoutineType; 
#elif (__BORLANDC__ && __MSDOS32X__)
typedef void far32 InterruptRoutineType; 
#else
typedef void far32 _loadds InterruptRoutineType; 
#endif

/****************************** G L O B A L S *****************************/


/******************************* M A C R O S ******************************/


/****************** F U N C T I O N   P R O T O T Y P E S *****************/

extern BOOL far32 ChangeInterruptRate(WORD handle, WORD rate);
#define ChangeTimerRate(handle,rate) ChangeInterruptRate(handle,rate)
extern void far32 CloseTimers(void);
extern WORD far32 InstallInterrupt(InterruptRoutineType (*routine)(void), WORD rate);
extern WORD far32 InstallTimer(void far32 *timer, WORD rate, WORD size, WORD direction);
extern WORD far32 InstallVBlank(InterruptRoutineType (*routine)(void));
extern void far32 OpenTimers(void);
extern BOOL far32 RemoveInterrupt(WORD handle);
#define RemoveTimer(handle) RemoveInterrupt(handle)
extern BOOL far32 RemoveVBlank(WORD handle);
extern BOOL far32 ResetTimer(WORD handle, ULONG value);

#ifdef __cplusplus
}
#endif

#endif /* TIMER_H */

