/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * EUIMSG.C
 *
 * PROGRAMMER : Gregg A. Tavares
 *    VERSION : 00.000
 *    CREATED : 12/17/90
 *   MODIFIED : 07/27/94
 *       TABS : 05 09
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
 * DESCRIPTION
 *		Basic EUI message loop. Either call directly or use as a model.
 *
 * HISTORY
 *		04/05/94 Tuesday (dcc) - separated from EUI.C.
 *
*/

#include <echidna/platform.h>

#include <echidna/eui.h>
#include <echidna/menus2.h>

/**************************** C O N S T A N T S ***************************/


/******************************** T Y P E S *******************************/


/****************************** G L O B A L S *****************************/

short				 ExitProgram;

/******************************* M A C R O S ******************************/


/***************************** R O U T I N E S ****************************/


/*********************************************************************
 *
 * EUIMessageLoop
 *
 * PURPOSE
 *		Processes EUI Events in the most standard way.
 *
 * INPUT
 *
 *
 * EFFECTS
 *
 *
 * RETURN VALUE
 *
 *
 * HISTORY
 *
 *
 * SEE ALSO
 *
*/
void EUIMessageLoop (void)
{

/*-------------------------------------------------------------------------*/
#if FUNC_NAMES
 CurrentFuncName = "EUIMessageLoop";
#endif
#if REQUIRE

#endif
/*-------------------------------------------------------------------------*/
	{
		MouseInfo	mi;

		while (!ExitProgram)
		{
			ReadMouse (&mi);
			if (mi.Buttons & MOUSE_RIGHTBUTTON)
			{
				HandleMenus (MainWindow, &mi);
			}
			HandleKeys (MainWindow);
		}
	}

} /* EUIMessageLoop */

