/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * events.h
 *
 * Events and State Variables
 *
 *	     \|///-_
 *	     \oo///_
 *	-----w/-w------
 *	 E C H I D N A
 *	---------------
 *
*/

#ifndef EVENTS_H
#define EVENTS_H

#include <echidna/platform.h>
#include "switches.h"

#include <echidna/menus2.h>


/*
 * State variables.
 */
extern short	ShowTitleSTATE;
extern short	WLTS;
extern short	WLTE;
extern short	WLC2;
extern short	SpaceSTATE;
extern short	CycleColorsSTATE;
extern short	SwankyModeSTATE;
extern short	ScrollLockSTATE;
extern short	LockRoomSTATE;
extern short	ShowOnlyFloorSTATE;
extern short	JamPaletteSTATE;
extern short	ShowBrushSTATE;
extern short	XFlipBrushSTATE;
extern short	YFlipBrushSTATE;

/*
 * Events.
 */
extern EventState	ClearMapState;
extern EventState	LoadMapState;
extern EventState	AppendMapState;
extern EventState	SaveMapState;
extern EventState	ZaveMapState;
extern EventState	tumeInfoState;
extern EventState	EditRoomState;
extern EventState	DrawRandomState;
extern EventState	ToggleTitleBarState;
extern EventState	AboutState;
extern EventState	QuitState;
extern EventState	QuitAndExitState;
extern EventState	LoadTilesFullTiledState;
extern EventState	LoadTilesFullTiledNoBlankState;
extern EventState	LoadTilesCookieCutterState;
extern EventState	LoadTilesBoxedState;
extern EventState	SelectBlockState;
extern EventState	SelectSquareState;
extern EventState	CreateRoomState;
extern EventState	DeleteRoomState;
extern EventState	LoadRoomState;
extern EventState	SaveRoomState;
extern EventState	SaveRoomAllState;
extern EventState	ClearRoomState;
extern EventState	ClearRoom2State;
extern EventState	ClearRoom3State;
extern EventState	WCreateState;
extern EventState	WCloseState;
extern EventState	PreviousRoomState;
extern EventState	NextRoomState;
extern EventState	FlipPanesState;
extern EventState	WLockToSourceState;
extern EventState	WLockToEditState;
extern EventState	WLockToSameState;
extern EventState	WLockClearState;
extern EventState	SpaceToggleState;
extern EventState	RightScrollState;
extern EventState	LeftScrollState;
extern EventState	UpScrollState;
extern EventState	DownScrollState;
extern EventState	RightScrollMultipleState;
extern EventState	LeftScrollMultipleState;
extern EventState	UpScrollMultipleState;
extern EventState	DownScrollMultipleState;
extern EventState	CenterRoomOnCursorState;
extern EventState	FloorUpState;
extern EventState	FloorDownState;
extern EventState	OpenLayerState;
extern EventState	CloseLayerState;
extern EventState	RoomStatusState;
extern EventState	VersionStatusState;
extern EventState	CopyrightStatusState;
extern EventState	CursorStatusState;
extern EventState	UserStatusState;
extern EventState	TileStatusState;
extern EventState	ToggleCycleColorsState;
extern EventState	SetTheColorsState;
extern EventState	ToggleSwankyModeState;
extern EventState	ScrollLockState;
extern EventState	ScrollLockKEYState;
extern EventState	UndoState;
extern EventState	RenameRoomState;
extern EventState	RoomInfoState;
extern EventState	TilesetUserState;
extern EventState	RoomUserState;
extern EventState	ToggleLockRoomState;
extern EventState	ToggleLInvisiState;
extern EventState	ToggleLLockState;
extern EventState	ToggleLAllState;
extern EventState	StripDownBlockCopyState;
extern EventState	CopyColors1State;
extern EventState	CopyColors2State;
extern EventState	CopyColors3State;
extern EventState	ShowOnlyFloorState;
extern EventState	NTIMarkState;
extern EventState	LastMenuEventState;
extern EventState	IncBackColorState;
extern EventState	DecBackColorState;
extern EventState	ZeroBackColorState;
extern EventState	TileComment1State;
extern EventState	TileComment2State;
extern EventState	HideCursorState;
extern EventState	DebugState;
extern EventState	GroupSaveTilesState;
extern EventState	SaveTilesAsBrushesState;
extern EventState	MakeColor1State;
extern EventState	MakeColor2State;
extern EventState	MakeColor3State;
extern EventState	MakeColor4State;
extern EventState	MakeColorRevertState;
extern EventState	ToggleJamPaletteState;
extern EventState	ToggleShowBrushState;
extern EventState	XFlipBrushState;
extern EventState	YFlipBrushState;

#endif /* EVENTS_H */

