/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

#include <echidna/grafx.h>
#include <echidna/fonts.h>

#define DS(msg)	\
	SetPenColor (255);						\
	DrawRect (10, 150, 25*8, 8);			\
 	DrawString (&MainFont, 10, 150, msg);	\

extern Font MainFont;
extern short ExitProgram;

void LMap							(void) { DS ("LMap                         "); };
void AMap							(void) { DS ("AMap                         "); };
void SMap2							(void) { DS ("SMap2                        "); };
void EditRoom						(void) { DS ("EditRoom                     "); };
void DrawRandom						(void) { DS ("DrawRandom                   "); };
void ToggleTitleBar					(void) { DS ("ToggleTitleBar               "); };
void Quit							(void) { DS ("Quit                         "); ExitProgram = TRUE; };
void QuitAndExit					(void) { DS ("QuitAndExit                  "); ExitProgram = TRUE; };
void TE_LoadTilesFullTiled			(void) { DS ("TE_LoadTilesFullTiled        "); };
void TE_LoadTilesFullTiledNoBlank	(void) { DS ("TE_LoadTilesFullTiledNoBlank "); };
void TE_LoadTilesCookieCutter		(void) { DS ("TE_LoadTilesCookieCutter     "); };
void TE_LoadTilesBoxed				(void) { DS ("TE_LoadTilesBoxed            "); };
void US								(void) { DS ("US                           "); };
void US2							(void) { DS ("US2                          "); };
void CRoom							(void) { DS ("CRoom                        "); };
void DRoom							(void) { DS ("DRoom                        "); };
void LRoom							(void) { DS ("LRoom                        "); };
void SRoom							(void) { DS ("SRoom                        "); };
void SRoomAll						(void) { DS ("SRoomAll                     "); };
void ClearRoom						(void) { DS ("ClearRoom                    "); };
void ClearRoom2						(void) { DS ("ClearRoom2                   "); };
void ClearRoom3						(void) { DS ("ClearRoom3                   "); };
void WCreate						(void) { DS ("WCreate                      "); };
void WClose							(void) { DS ("WClose                       "); };
void WPRoom							(void) { DS ("WPRoom                       "); };
void WNRoom							(void) { DS ("WNRoom                       "); };
void WFRoom							(void) { DS ("WFRoom                       "); };
void WLS							(void) { DS ("WLS                          "); };
void WLE							(void) { DS ("WLE                          "); };
void WLC							(void) { DS ("WLC                          "); };
void WLCl							(void) { DS ("WLCl                         "); };
void SpaceToggle					(void) { DS ("SpaceToggle                  "); };
void RightScroll					(void) { DS ("RightScroll                  "); };
void LeftScroll						(void) { DS ("LeftScroll                   "); };
void UpScroll						(void) { DS ("UpScroll                     "); };
void DownScroll						(void) { DS ("DownScroll                   "); };
void RightScrollMultiple			(void) { DS ("RightScrollMultiple          "); };
void LeftScrollMultiple				(void) { DS ("LeftScrollMultiple           "); };
void UpScrollMultiple				(void) { DS ("UpScrollMultiple             "); };
void DownScrollMultiple				(void) { DS ("DownScrollMultiple           "); };
void CenterRoomOnCursor				(void) { DS ("CenterRoomOnCursor           "); };
void FloorUp						(void) { DS ("FloorUp                      "); };
void FloorDown						(void) { DS ("FloorDown                    "); };
void OpenLayer						(void) { DS ("OpenLayer                    "); };
void CloseLayer						(void) { DS ("CloseLayer                   "); };
void RoomStatus						(void) { DS ("RoomStatus                   "); };
void VersionStatus					(void) { DS ("VersionStatus                "); };
void CopyrightStatus				(void) { DS ("CopyrightStatus              "); };
void CursorStatus					(void) { DS ("CursorStatus                 "); };
void UserStatus						(void) { DS ("UserStatus                   "); };
void TUserStatus					(void) { DS ("TUserStatus                  "); };
void ToggleSwankyMode				(void) { DS ("ToggleSwankyMode             "); };
void ScrollLock						(void) { DS ("ScrollLock                   "); };
void ScrollLockKEY					(void) { DS ("ScrollLockKEY                "); };
void RenameRoom						(void) { DS ("RenameRoom                   "); };
void RInfo							(void) { DS ("RInfo                        "); };
void TUser							(void) { DS ("TUser                        "); };
void URoom							(void) { DS ("URoom                        "); };
void ToggleLockRoom					(void) { DS ("ToggleLockRoom               "); };
void ToggleLInvisi					(void) { DS ("ToggleLInvisi                "); };
void ToggleLLock					(void) { DS ("ToggleLLock                  "); };
void ToggleLAll						(void) { DS ("ToggleLAll                   "); };
void StripDownBlockCopy				(void) { DS ("StripDownBlockCopy           "); };
void CopyColors1					(void) { DS ("CopyColors1                  "); };
void CopyColors2					(void) { DS ("CopyColors2                  "); };
void CopyColors3					(void) { DS ("CopyColors3                  "); };
void ShowOnlyFloor					(void) { DS ("ShowOnlyFloor                "); };
void NTIMark						(void) { DS ("NTIMark                      "); };
void IncGColor						(void) { DS ("IncGColor                    "); };
void DecGColor						(void) { DS ("DecGColor                    "); };
void ZGColor						(void) { DS ("ZGColor                      "); };
void TileComment1					(void) { DS ("TileComment1                 "); };
void TileComment2					(void) { DS ("TileComment2                 "); };
void TE_TogglePointer				(void) { DS ("TE_TogglePointer             "); };
void TE_Debug						(void) { DS ("TE_Debug                     "); };
void SMap3							(void) { DS ("SMap3                        "); };
void TE_SaveTilesAsBrushes			(void) { DS ("TE_SaveTilesAsBrushes        "); };
void TE_MakeColor1					(void) { DS ("TE_MakeColor1                "); };
void TE_MakeColor2					(void) { DS ("TE_MakeColor2                "); };
void TE_MakeColor3					(void) { DS ("TE_MakeColor3                "); };
void TE_MakeColor4					(void) { DS ("TE_MakeColor4                "); };
void TE_MakeColorRevert				(void) { DS ("TE_MakeColorRevert           "); };
void ToggleJamPalette				(void) { DS ("ToggleJamPalette             "); };
void ToggleShowBrush				(void) { DS ("ToggleShowBrush              "); };
void XFlipBrush						(void) { DS ("XFlipBrush                   "); };
void YFlipBrush						(void) { DS ("YFlipBrush                   "); };

