;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** TCLEAR.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 03/05/90
;**   MODIFIED : 09/14/90
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	Routine to clear the entire screen with current color.
;**
;** HISTORY
;**
;**
	IDEAL

;=====================================================================
;**
;** _TGA_ClearScreen
;** TGA_ClearScreen
;**
;** PURPOSE
;**	Clear an TGA screen with curren PaperColor.
;**
;** INPUT
;**	PaperColor = color to clear with.
;**	GrSeq      = SEGMENT of Screen to clear
;**
;** REGISTER USED
;**	AX, CX, ES, DI
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	MPROC	_TGA_ClearScreen
	MPROC	TGA_ClearScreen

	push	bp
	mov	bp,sp
	push	di

			;
			; ax -> es:di
			;
	sub	di,di	; Clear DI
	mov	bx,[CS:TGrSeg]	; Point Hardware to current page
	mov	ax,[CS:_TDAcsTbl+bx]	;
	or	al,[CS:_TDispVal]	; Or in current display
	mov	dx,03DFh
	out	dx,al
	mov	bx,[CS:_TDMemTbl+bx]	; Get current page's segment
	mov	es,bx

	xor	bh,bh
	mov	bl,[CS:TPaperColor]	; Get Paper Color.
	mov	al,[CS:_TGAEvenPatTbl+bx]	;Get Even Pattern image.
	mov	ah,al

	mov	cx,4000	; Set Length to quarter screen.
	cld		; Set direction to Forward.
	rep stosw	; Do '0' lines.


	mov	di,04000h	; Setup for '2' lines.
	mov	cx,4000	; Set Length to quarter screen.
	rep stosw	; Do '2' lines.

	mov	al,[CS:_TGAOddPatTbl+bx]	;Get Odd pattern image.
	mov	ah,al

	mov	di,02000h	; Setup for '1' lines.
	mov	cx,4000	; Set Length to quarter screen.
	rep stosw	; Do '1' lines.

	mov	di,06000h	; Setup for '3' lines.
	mov	cx,4000	; Set Length to quarter screen.
	rep stosw	; Do '3' lines.

	pop	di
	pop	bp

	ret

	ENDP
	ENDP

