;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** TSHAPE.asm
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 03/06/90
;**   MODIFIED : 10/02/92
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	Shape routines for TGA (originally written by John Reego)
;**	and modified by Gregg A. Tavares
;**
;** HISTORY
;**
;**




; DRAW_SPRITE (sprite #, Xw, Yw)  {SI, BX, CX}
;
;     sprite #  - address of sprite structure found in sprite_addr_table
;     Xw        - X position in world coordinates (w)
;     Yw        - Y position in world coordinates (w)

; sprite_addr_table
;        DD      sprite address 0
;        DD      sprite address 1
;        DD      sprite address 2
;        DD      sprite address .
;        DD      sprite address n
;
; sprite_structure
;       DW       x adjustment
;       DW       x length
;       DW       y adjustment
;       DW       y length
;       DB       SPRITE DATA  ...
;
; ABSx1 - least    x pixel address of screen in world coordinates
; ABSx2 - greatest x pixel address of screen in world coordinates
; ABSy1 - least    y pixel address of screen in world coordinates
; ABSy2 - greatest y pixel address of screen in world coordinates
;
; SPRx1 - least    x pixel address of sprite in world coordinates
; SPRx2 - greatest x pixel address of sprite in world coordinates
; SPRy1 - least    y pixel address of sprite in world coordinates
; SPRy2 - greatest y pixel address of sprite in world coordinates
;
; ABS x1, x2, y1, y2 should already be computed

	PROC CLIP_DATA NEAR

LABEL WrapSt  WORD              ; Lookup table for line start addresses
%NOLIST
        REPT 50
        dw     0h
        dw  2000h
        dw  4000h
        dw  6000h
        ENDM
%LIST

LABEL WrapCt  WORD              ; Lookup table for line start addresses
%NOLIST
        REPT 50
        dw  2000h
        dw  4000h
        dw  6000h
        dw  8000h
        ENDM
%LIST

CLIP_LEFT     dw  ?
CLIP_RIGHT    dw  ?
CLIP_TOP      dw  ?
CLIP_BOTTOM   dw  ?
START_X       dw  ?
START_Y       dw  ?
CLIP_VALUE    dw  ?

X_LENGTH      dw  0                              ; fail RESTORE_BGND
REAL_X_LENGTH dw  ?
LINES_TO_GO   dw  ?
X_adjust      dw  ?
LINE_ADDR     dw  ?
ScrnAddr      dw  ?
LINE_CTR      dw  ?

ABSx1         dw  0
ABSx2         dw  319
ABSy1         dw  0
ABSy2         dw  199
NextABSx1    dw  ?
NextABSy1    dw  ?
Screen_Up    db  ?                      ; screen moving up
Screen_Down  db  ?                      ; screen moving down flag
Screen_Right db  ?
Screen_Left  db  ?

SPRx1         dw  ?
SPRx2         dw  ?
SPRy1         dw  ?
SPRy2         dw  ?

ds_save       dw  ?
si_save       dw  ?

	if 0
Label   sprite_addr_table DWORD
        dw      test_sprite1
        dw      Code
        dw      test_sprite2
        dw      Code
        DD 256 DUP (?)                  ; space for sprite address table

LABEL   test_sprite1 byte
        dw      0, 5, 0, 3      ; x_adj, x_len, y_adj, y_len
        db      3,0ffh,0,0fh,10h, 0, 4,0ffh,0,0f0h,01h
        db      1,11h, 5,0ffh,0,0fh,10h, 0, 2,0ffh,0,0ffh,0

LABEL   test_sprite2 byte
        dw      0, 12, 0, 15             ; x_adj, x_len, y_adj, y_len
        db      3,0ffh,0,0f0h,06h, 2,66h,66h, 9,0ffh,0,0ffh,0
        db      4,66h,66h,66h,66h, 8,0ffh,0,0f0h,06h, 4,66h,66h,66h,66h
        db      7,0fh,60h,0f0h,02h, 6,26h,66h,66h,66h,66h,62h
        db      2,0fh,20h,0ffh,0, 1,44h, 2,0fh,40h,0ffh,0
        db      8,22h,26h,66h,66h,66h,66h,62h,22h, 2,0ffh,0,0,44h, 1,44h, 2,0ffh,0,0,22h
        db      7,22h,66h,66h,66h,66h,22h,22h, 2,0f0h,04h,0,44h, 1,44h, 2,0ffh,0,0f0h,02h
        db      6,22h,22h,66h,66h,22h,22h, 2,0fh,20h,0f0h,04h, 1,44h
        db      4,0fh,40h,0,22h, 5,22h,22h,22h,22h,22h, 2,0fh,20h,0,44h, 1,44h, 4,0ffh,0,0,22h, 0
        db      2,0fh,20h,0,22h, 1,22h, 2,0fh,20h, 0,22h, 0, 1,0fh,20h,0ffh,0, 1,44h
        db      5,0fh,40h,0,22h
        db      0, 2,0fh,20h,0f0h,08h, 0, 2,0f0h,08h,0ffh,0, 1,22h, 2,0fh,20h,0fh,40h
        db      0, 5,0ffh,0,0,2ch
        db      1,0cch, 4,0fh,0c0h,0,22h, 1,24h, 5,0ffh,0,0f0h,0ch
        db      2,0cch,0cch, 4,0fh,70h,0f0h,06h, 0, 6,00fh,40h,0f0h,07h
        db      2,0cch,0c7h, 4,0ffh,0,0,64h, 0, 7,0fh,60h,0,7ch
        db      0, 5,0fh,70h,0fh,40h, 0, 7,0ffh,0,0f0h,07h, 0, 10,0ffh,0,0ffh,0
	endif

LABEL   CASE_TABLE  WORD
        dw      DRAW_BEGIN      ; 0
        dw      CL_BEGIN        ; 1
        dw      CR_BEGIN        ; 2
        dw      CT_BEGIN        ; 3
        dw      CTL_BEGIN       ; 4
        dw      CTR_BEGIN       ; 5
        dw      DRAW_BEGIN      ; 6
        dw      CL_BEGIN        ; 7
        dw      CR_BEGIN        ; 8

which_case   db  ?

ENDP CLIP_DATA


	PROC DRAW_SPRITEx NEAR
off_screen:
        sub   bx, bx                            ;
        ret
early_exit:
        sub   bx, bx                            ; set X_LENGTH to zero
        ret
DRAW_SPRITE1:
        cld
        mov   ax, cs
        mov   es, ax
;--------------------------------------------------------------------------
;       COMPUTE EDGES OF SPRITE IN WORLD COORDINATES
;
;          INPUT:  bx = x_addr of sprite in world coordinates
;                  cx = y_addr of sprite in world coordinates
;                  si = sprite number
;--------------------------------------------------------------------------
        LODSW                                   ; compute SPRx1
        add   bx, ax                            ;
        mov   [cs:SPRx1], bx                    ;
        LODSW                                   ; compute SPRx2
        mov   [cs:X_LENGTH], ax                 ; save X_LENGTH
        shl   ax, 1                             ;
        add   bx, ax                            ;
        dec   bx                                ;
        mov   [cs:SPRx2], bx                    ;
        LODSW                                   ; compute SPRy1
        add   cx, ax                            ;
        mov   [cs:SPRy1], cx                    ;
        LODSW                                   ; compute SPRy2
        mov   [cs:LINES_TO_GO], ax              ; save Y_LENGTH
        add   cx, ax                            ;
        dec   cx                                ;
        mov   [cs:SPRy2], cx                    ;
;--------------------------------------------------------------------------
;       IS ANY PART OF THE SPRITE ON THE VIEWING SCREEN ?
;--------------------------------------------------------------------------
        mov   [cs:ds_save], ds                  ; save ds {sprite_data}
        mov   ax, cs                            ; restore ds
        mov   ds, ax                            ;
        mov   [si_save], si                     ; save si {sprite data}

        mov   [which_case], 0                   ; assume no clipping
        mov   ax, [SPRy1]                       ; SPRITE BELOW SCREEN ?
        cmp   ax, [ABSy2]                       ;
        jg    earlyexit                         ;
        mov   ax, [SPRy2]                       ; SPRITE ABOVE SCREEN ?
        cmp   ax, [ABSy1]                       ;
        jl    earlyexit                         ;
        mov   ax, [SPRx1]                       ; SPRITE RIGHT OF SCREEN ?
        cmp   ax, [ABSx2]                       ;
        jg    earlyexit                         ;
        mov   ax, [SPRx2]                       ; SPRITE LEFT OF SCREEN ?
        cmp   ax, [ABSx1]                       ;
        jl    earlyexit                         ;
        jmp   SHORT keep_trucking
earlyexit:
        jmp   early_exit
offscrn:
        jmp   off_screen
keep_trucking:

;--------------------------------------------------------------------------
;       COMPUTE CLIPPING COMPONENTS (IF ANY)
;--------------------------------------------------------------------------
        sub   ax, ax                            ;
        lea   di, [CLIP_LEFT]                   ;
        mov   cx, 6                             ;
        REP   STOSW                             ; zero out clip variables

        mov   ax, [ABSx1]                       ; clip the left edge ?
        sub   ax, [SPRx1]                       ;
        js    not_neg_a                         ;
        jz    not_neg_b                         ;
        shr   ax, 1                             ; ^^
        mov   [CLIP_LEFT], ax                   ;
        add   [which_case], 1                   ;
        jmp SHORT   not_neg_b                         ;
not_neg_a:                                      ;
        neg   ax                                ;
        shr   ax, 1                             ; <<<MODIFY!!!>>>
        mov   [START_X], ax                     ;
do_right:
        mov   ax, [SPRx2]                       ; clip the right edge ?
        sub   ax, [ABSx2]                       ;
        js    not_neg_b                         ;
        je    not_neg_b                         ;
        shr   ax, 1                             ; ^^
        mov   [CLIP_RIGHT], ax                  ;
        add   [which_case], 2                   ;

not_neg_b:                                      ;
        mov   ax, [ABSy1]                       ; clip the top ?
        sub   ax, [SPRy1]                       ;
        js    not_neg_c                         ;
        jz    not_neg_d
        mov   [CLIP_TOP], ax                    ;
        add   [which_case], 3                   ;
        jmp SHORT   not_neg_d                         ;
not_neg_c:                                      ;
        neg   ax                                ;
        mov   [START_Y], ax                     ;

do_bottom:

        mov   ax, [SPRy2]                       ; clip the bottom ?
        sub   ax, [ABSy2]                       ;
        js    not_neg_d                         ;
        jz    not_neg_d                         ;
        mov   [CLIP_BOTTOM], ax                 ;
        add   [which_case], 6                   ;
not_neg_d:                                      ;

;--------------------------------------------------------------------------
;     CLIPPING ALGORITHM    ah must = 0
;                           bx = pixels remaining to DRAW / CLIP
; CASE:                     cx = # data bits DATA / TRANS
;     4--3--5               dx = LINES_TO_GO
;     1  0  2               bp = X_adjust  (where DRAW starts for each line)
;     7--6--8               ds:si --> sprite data
;                           es:di --> screen address in DRAW modes
;--------------------------------------------------------------------------

        mov   ax, [X_LENGTH]            ;
        mov   [REAL_X_LENGTH], ax       ;
        sub   ax, [CLIP_RIGHT]          ;
        sub   ax, [CLIP_LEFT]           ;
        mov   [X_LENGTH], ax            ;

        mov   ax, [LINES_TO_GO]         ;
        sub   ax, [CLIP_TOP]            ;
        sub   ax, [CLIP_BOTTOM]         ;
        mov   [LINES_TO_GO], ax         ;
        mov   bx, 1
        ret

DRAW_SPRITE2:
        cld
        mov   bp, [START_Y]             ;# bp = START_Y * 2
        shl   bp, 1                     ;#
;        mov   ax, [ScrnPtrI]            ;# add scroll address
;        shl   ax,1                      ;#
;        mov   [ScrnAddr], ax            ;#
        mov   ax, [START_X]             ;#
        mov   [LINE_ADDR], ax           ;#
        mov   ax, [START_X]             ;#
        mov   [X_adjust], ax            ;#

        mov   ax, [LINES_TO_GO]         ; dx = LINES_TO_GO
        mov   [LINE_CTR], ax

	mov	bx,[CS:TGrSeg]	;GAT Point Hardware to current page
	mov	ax,[CS:_TDAcsTbl+bx]	;GAT
	or	al,[CS:_TDispVal]	;GAT Or in current display
	mov	dx,03DFh	;GAT
	out	dx,al	;GAT
	mov	bx,[CS:_TDMemTbl+bx]	;GAT Get current page's segment
	mov	es,bx	;GAT

        mov   si, [si_save]             ; restore si --> sprite data

        mov   bl, [which_case]          ;
        sub   bh, bh                    ;
        shl   bx, 1                     ;
        jmp   [case_table+bx]           ;

;--------------------------------------------------------------------------
;    ENTRY POINTS
;--------------------------------------------------------------------------

CTL_BEGIN:                                      ; CASE 4, Clear Top Left

        dec   bp                                ;# point back 1 line (use cr rtn)
        dec   bp                                ;#
        mov   bx, [CLIP_LEFT]                   ;
        mov   [CLIP_VALUE], bx                  ;
        push  bx                                ;
; ---------------------------------------------------------------------
        mov   bx, [CLIP_TOP]
        mov   ax, [REAL_X_LENGTH]
        mul   bl
        mov   bx, ax
        mov   ds, [ds_save]
        sub   ah, ah
        LODSB
        mov   ch, al                            ;#
CTL_TRAN:
        cmp   ax, bx
        ja    CTL_TRAN_gr
        je    CTL_TRAN_eq
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CTL_a1                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTL_a1:                                         ;#
        inc   si                                ;#
        inc   si                                ;#
        sub   bx, ax
        LODSB
        jmp SHORT   CTL_DATA

CTL_TRAN_eq:
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CTL_eq                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTL_eq:                                         ;#
        inc   si                                ;#
        inc   si                                ;#
        LODSB
        pop   bx
        jmp   CR_CLIP_DATA

CTL_TRAN_gr:
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   CTL_gr                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTL_gr:                                         ;#
        sub   ax, bx
        pop   bx
        jmp   CR_CLIP_TRANS

CTL_DATA:
        cmp   ax, bx
        ja    CTL_DATA_gr
        je    CTL_DATA_eq
        sub   bx, ax
        add   si, ax
        LODSB
        mov   ch, al                            ;#
        jmp SHORT   CTL_TRAN

CTL_DATA_eq:
        add   si, ax
        LODSB
        mov   ch, al                            ;#
        pop   bx
        jmp   CR_CLIP_TRANS

CTL_DATA_gr:
        sub   ax, bx
        add   si, bx
        pop   bx
        jmp   CR_CLIP_DATA
; ---------------------------------------------------------------------
CTR_BEGIN:                                      ; CASES (2, 8)
        mov   ax, [CLIP_RIGHT]                  ;
        mov   [CLIP_VALUE], ax                  ;
        mov   bx, [X_LENGTH]                    ;
        push  bx                                ;
        mov   di, [ds:LineSt+bp]                ;#
        mov   dx, [ds:WrapSt+bp]                ;#
        add   di, [LINE_ADDR]                   ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#

; ---------------------------------------------------------------------
        mov   bx, [CLIP_TOP]                    ;
        mov   ax, [REAL_X_LENGTH]
        mul   bl
        mov   bx, ax
        mov   ds, [ds_save]                     ;
        sub   ah, ah                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
CTR_TRAN:                                       ;
        cmp   ax, bx                            ;
        ja    CTR_TRAN_gr                       ;
        je    CTR_TRAN_eq                       ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CTR_a1                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTR_a1:                                         ;#
        inc   si                                ;#
        inc   si                                ;#
        sub   bx, ax                            ;
        LODSB                                   ;
        jmp SHORT   CTR_DATA                    ;
                                                ;
CTR_TRAN_eq:                                    ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CTR_b1                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTR_b1:                                         ;#
        inc   si                                ;#
        inc   si                                ;#
        LODSB                                   ;
        pop   bx                                ;
        jmp   CR_DRAW_DATA                      ;

CTR_TRAN_gr:                                    ;
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   CTR_gr                            ;#
        inc   si                                ;#
        inc   si                                ;#
CTR_gr:                                         ;#
        sub   ax, bx                            ;
        pop   bx                                ;
        jmp   CR_DRAW_TRANS                     ;

CTR_DATA:                                       ;
        cmp   ax, bx                            ;
        ja    CTR_DATA_gr                       ;
        je    CTR_DATA_eq                       ;
        sub   bx, ax                            ;
        add   si, ax                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
        jmp SHORT   CTR_TRAN                    ;

CTR_DATA_eq:                                    ;
        add   si, ax                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
        pop   bx                                ;
        jmp   CR_DRAW_TRANS                     ;
                                                ;
CTR_DATA_gr:                                    ;
        sub   ax, bx                            ;
        add   si, bx
        pop   bx                                ;
        jmp   CR_DRAW_DATA                      ;
; ---------------------------------------------------------------------
CT_BEGIN:                                       ; CASES (0, 6)
        mov   [CLIP_VALUE], 0                   ;
        mov   bx, [X_LENGTH]                    ;
        mov   di, [ds:LineSt+bp]                ;#
        mov   dx, [ds:WrapSt+bp]                ;#
        add   di, [LINE_ADDR]                   ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        push  bx                                ;
; ---------------------------------------------------------------------
        mov   bx, [CLIP_TOP]                    ;
        mov   ax, [REAL_X_LENGTH]
        mul   bl
        mov   bx, ax
        mov   ds, [ds_save]                     ;
        sub   ah, ah                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
CT_TRAN:                                        ;
        cmp   ax, bx                            ;
        ja    CT_TRAN_gr                        ;
        je    CT_TRAN_eq                        ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CT_a1                             ;#
        inc   si                                ;#
        inc   si                                ;#
CT_a1:                                          ;#
        inc   si                                ;#
        inc   si                                ;#
        sub   bx, ax                            ;
        LODSB                                   ;
        jmp SHORT   CT_DATA                     ;
                                                ;
CT_TRAN_eq:                                     ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CT_b1                             ;#
        inc   si                                ;#
        inc   si                                ;#
CT_b1:                                          ;#
        inc   si                                ;#
        inc   si                                ;#
        LODSB                                   ;
        pop   bx                                ;
        jmp   DRAW_DATA                         ;
                                                ;
CT_TRAN_gr:                                     ;
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   CT_gr                             ;#
        inc   si                                ;#
        inc   si                                ;#
CT_gr:                                          ;#
        sub   ax, bx                            ;
        pop   bx                                ;
        jmp   DRAW_TRANS                        ;
                                                ;
CT_DATA:                                        ;
        cmp   ax, bx                            ;
        ja    CT_DATA_gr                        ;
        je    CT_DATA_eq                        ;
        sub   bx, ax                            ;
        add   si, ax                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
        jmp SHORT   CT_TRAN                     ;

CT_DATA_eq:                                     ;
        add   si, ax                            ;
        LODSB                                   ;
        mov   ch, al                            ;#
        pop   bx                                ;
        jmp   DRAW_TRANS                        ;

CT_DATA_gr:                                     ;
        sub   ax, bx                            ;
        add   si, bx
        pop   bx                                ;
        jmp   DRAW_DATA                         ;
; ---------------------------------------------------------------------


CL_BEGIN:                                       ; CASES (1, 7)

        dec   bp                                ;# point back 1 line (use cr rtn)
        dec   bp                                ;#
        mov   bx, [CLIP_LEFT]                   ;
        mov   [CLIP_VALUE], bx                  ;
        mov   ds, [ds_save]                     ; CLIP_LEFT
        sub   ah, ah                            ;
        LODSB                                   ;
        mov   ch, al                            ;# save initial trans value
        jmp   CR_CLIP_TRANS                     ;

CR_BEGIN:                                       ; CASES (2, 8)
        mov   ax, [CLIP_RIGHT]                  ;
        mov   [CLIP_VALUE], ax                  ;
        mov   bx, [X_LENGTH]                    ;
        mov   di, [ds:LineSt+bp]                ;# Get address to draw to
        mov   dx, [ds:WrapSt+bp]                ;#
        add   di, [LINE_ADDR]                   ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   ds, [ds_SAVE]                     ;
        sub   ah, ah                            ;
        LODSB                                   ;
        mov   ch, al                            ;# save initial trans value
        jmp   CR_DRAW_TRANS                     ;

DRAW_BEGIN:                                     ; CASES (0, 6)
        mov   [CLIP_VALUE], 0                   ;
        mov   bx, [X_LENGTH]                    ;
        mov   di, [ds:LineSt+bp]                ;#
        mov   dx, [ds:WrapSt+bp]                ;#
        add   di, [LINE_ADDR]                   ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   ds, [ds_save]                     ;
        sub   ah, ah                            ;
        LODSB                                   ;
        mov   ch, al                            ; save initial trans value
        jmp SHORT   DRAW_TRANS                  ;


;--------------------------------------------------------------------------
;    DRAW SPRITE WITHOUT CLIPPING
;--------------------------------------------------------------------------

DT_gr:                                          ;
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   DT_c1                             ;#
        mov   cl, al                            ;# save al
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Read the Mask
        and   [es:di], al                       ;# And in the Mask
        LODSB                                   ;# Read the Data
        or    [es:di], al                       ;# Or in the Data
        mov   al, cl                            ;# restore al
DT_c1:                                          ;#
        dec   [cs:LINE_CTR]                     ;#
        jnz   tutu                              ; <<< this test can be shortened >>>
        jmp   ALL_DONE                          ;
tutu:                                           ;
        sub   ax, bx                            ;
        inc   bp                                ;# point to start of next line
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   bx, [cs:X_LENGTH]                    ;
        jmp   DRAW_TRANS                        ;

DRAW_TRANS:                                     ;      **** ENTRY POINT ****
        cmp   ax, bx                            ;
        ja    DT_gr                             ;
        je    DT_eq                             ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   DT_a1                             ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Load the Mask Bits
        and   [es:di], al                       ;# And in the Mask Bits
        LODSB                                   ;# Load the Data Bits
        or    [es:di], al                       ;# Or in the Data Bits
        mov   al, ch                            ;# restore the trans count

DT_a1:                                          ;#
        add   di, ax                            ; adjust video pointer
        sub   bx, ax                            ; adjust tran count
        dec   di                                ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;#
        and   [es:di], al                       ;#
        LODSB                                   ;#
        or    [es:di], al                       ;#
        inc   di                                ;#
        LODSB                                   ;
        jmp   DRAW_DATA                         ;

DT_eq:                                          ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   DT_b1                             ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Read the Data Mask
        and   [es:di], al                       ;# And in the Mask Bits
        LODSB                                   ;# Read the Data Bits
        or    [es:di], al                       ;# Or in the Data Bits
        mov   al, ch                            ;# Restore al

DT_b1:                                          ;#
        add   di, ax                            ;# adjust video pointer to end
        dec   di                                ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;#
        and   [es:di], al                       ;#
        LODSB                                   ;#
        or    [es:di], al                       ;#
        inc   di                                ;#
        dec   [cs:LINE_CTR]                     ;#
        jnz   xyz                               ;<<< this instruction can be shortened >>>
        jmp   ALL_DONE
xyz:
        inc   bp                                ;# point to start of next line
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        LODSB                                   ;
        mov   bx, [cs:X_LENGTH]                    ;
        jmp SHORT   DRAW_DATA                   ;

wALL_DONE:                                      ;#
        jmp   ALL_DONE                          ;#

L3:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL3                              ;#
L3a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L3a                               ;#
        jmp   unL3                              ;#

DD_gr:                                          ;
        sub   ax, bx                            ;
        xchg  bx, ax                            ;
        mov   cx, ax                            ;
        add   di, cx                            ;#
        cmp   di, [cs:WrapCt+bp]                ;#
        jae   L3                                ;#
        sub   di, cx                            ;#
        REP   MOVSB                             ;#
unL3:
        dec   [cs:LINE_CTR]                     ;#
        jz    wALL_DONE                         ;
        mov   ax, bx                            ;
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   bx, [cs:X_LENGTH]                    ;
        jmp   DRAW_DATA                         ;

L1:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL1                              ;#
L1a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L1a                               ;#
        jmp   unL1                              ;#

DRAW_DATA:                                      ;     **** ENTRY POINT ****
        cmp   ax, bx                            ;
        ja    DD_gr                             ;
        je    DD_eq                             ;
        sub   bx, ax                            ;
        mov   cx, ax                            ;
        add   di, cx                            ;#
        cmp   di, [cs:WrapCt+bp]                ;#
        jae   L1                                ;#
        sub   di, cx                            ;#
        REP   MOVSB
unL1:
        LODSB                                   ;
        mov   ch, al                            ;#
        jmp   DRAW_TRANS                        ;

L2:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL2                              ;#
L2a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L2a                               ;#
        jmp   unL2                              ;#

yALL_DONE:                                      ;#
        jmp   ALL_DONE                          ;#

DD_eq:                                          ;
        mov   cx, ax                            ;
        add   di, cx                            ;#
        cmp   di, [cs:WrapCt+bp]                ;#
        jae   L2                                ;#
        sub   di, cx                            ;#
        REP   MOVSB
unL2:                                           ;#
        dec   [cs:LINE_CTR]                     ;#
        jz    yALL_DONE                         ;

        LODSB                                   ;
        mov   ch, al                            ;#
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   bx, [cs:X_LENGTH]                    ;
        jmp   DRAW_TRANS                        ;

ALL_DONE:                                       ;
        mov   ax, cs                            ;
        mov   ds, ax                            ;
        mov   ax, [START_X]
        shl   ax, 1
        add   ax, [ABSx1]
        mov   bx, [X_LENGTH]
        mov   cx, [START_Y]
        add   cx, [ABSy1]
        mov   dx, [LINES_TO_GO]
        ret                                     ;


;--------------------------------------------------------------------------
;    DRAW SPRITE WITH CLIPPING          CLIP RIGHT & CLIP LEFT
;--------------------------------------------------------------------------

CR_DRAW_TRANS:                                  ; (CASE 5, 2, 8)
        cmp   ax, bx                            ; trans bits, bits to go
        ja    CR_DT_gr                          ;
        je    CR_DT_eq                          ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CR_DT_a1                          ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Load the Mask Bits
        and   [es:di], al                       ;# And in the Mask Bits
        LODSB                                   ;# Load the Data Bits
        or    [es:di], al                       ;# Or in the Data Bits
        mov   al, ch                            ;# restore the trans count

CR_DT_a1:                                       ;#
        add   di, ax                            ; adjust video pointer
        sub   bx, ax                            ; adjust tran count
        dec   di                                ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;#
        and   [es:di], al                       ;#
        LODSB                                   ;#
        or    [es:di], al                       ;#
        inc   di                                ;#

        LODSB                                   ;
        jmp SHORT   CR_DRAW_DATA                ; go to data mode

CR_DT_eq:                                       ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CR_DT_b1                             ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Read the Data Mask
        and   [es:di], al                       ;# And in the Mask Bits
        LODSB                                   ;# Read the Data Bits
        or    [es:di], al                       ;# Or in the Data Bits
        mov   al, ch                            ;# Restore al

CR_DT_b1:                                       ;#
        add   di, ax                            ;# adjust video pointer to end
        dec   di                                ;#
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;#
        and   [es:di], al                       ;#
        LODSB                                   ;#
        or    [es:di], al                       ;#
        inc   di                                ;#
        dec   [cs:LINE_CTR]                     ;#
        jz    ALL_DONE                          ;
        LODSB                                   ;
        mov   bx, [cs:CLIP_VALUE]               ;
        jmp   CR_CLIP_DATA                      ;

CR_DT_gr:                                       ;
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   CR_DT_c1                          ;#
        mov   cl, al                            ;# save al
        and   di, 1fffh                         ;# point to correct video bank
        or    di, dx                            ;#
        LODSB                                   ;# Read the Mask
        and   [es:di], al                       ;# And in the Mask
        LODSB                                   ;# Read the Data
        or    [es:di], al                       ;# Or in the Data
        mov   al, cl                            ;# restore al
CR_DT_c1:                                       ;#
        dec   [cs:LINE_CTR]                     ;#
        jnz   goofy                             ; <<< can we shorten this ? >>>
        jmp   ALL_DONE                          ;
goofy:
        sub   ax, bx                            ; subtract from trans bit count
        mov   bx, [cs:CLIP_VALUE]               ;
        jmp   CR_CLIP_TRANS                     ;

L4:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL4                              ;#
L4a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L4a                               ;#
        jmp   unL4                              ;#

CR_DRAW_DATA:                                   ;  (CASE 5, 2, 8)
        cmp   ax, bx                            ;
        ja    CR_DD_gr                          ;
        je    CR_DD_eq                          ;
        sub   bx, ax                            ; draw area will not be filled
        mov   cx, ax                            ;
        add   di, cx                            ;#
        cmp   di, [cs:WrapCt+bp]                ;#
        jae   L4                                ;#
        sub   di, cx                            ;#
        REP   MOVSB                             ;
unL4:                                           ;#
        LODSB                                   ;
        mov   ch, al                            ;#
        jmp   CR_DRAW_TRANS                     ; draw the transparent bytes

L5:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL5                              ;#
L5a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L5a                               ;#
        jmp   unL5                              ;#

CR_DD_eq:                                       ;
        mov   cx, ax                            ;
        add   di, cx
        cmp   di, [cs:WrapCt+bp]
        jae   L5
        sub   di, cx
unL5:
        REP   MOVSB
        dec   [cs:LINE_CTR]                     ;#
        jz    xALL_DONE                         ;#
        LODSB                                   ;
        mov   ch, al                            ;#
        mov   bx, [cs:CLIP_VALUE]               ; establish clip_right length
        jmp SHORT   CR_CLIP_TRANS               ; goto clipright - transparent

xALL_DONE:                                      ;#
        jmp   ALL_DONE                          ;#

L6:                                             ;#
        sub   di, cx                            ;#
        or    cx, cx                            ;#
        jz    unL6                              ;#
L6a:
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        MOVSB                                   ;#
        loop  L6                                ;#
        jmp   unL6                              ;#

CR_DD_gr:                                       ;
        xchg  ax, bx                            ; bx = data count, ax = draw bits left
        sub   bx, ax                            ; bx = count left after draw
        mov   cx, ax                            ;
        add   di, cx                            ;#
        cmp   di, [cs:WrapCt+bp]                ;#
        jae   L6                                ;#
        sub   di, cx                            ;#
        REP   MOVSB                             ;
unL6:                                           ;#
        dec   [cs:LINE_CTR]                     ;#
        jz    xALL_DONE                         ;#
        mov   ax, bx                            ; ax = bits of data left
        mov   bx, [cs:CLIP_VALUE]               ; bx = clip right length
        jmp   CR_CLIP_DATA                      ;

CR_CLIP_TRANS:                                  ;
                ; ah = 0
                ; bx = clip length remaining
                ; ax = # of transparent bits remaining
                ; ds:si --> data count, data bits ...
                ; es:di --> doesn't matter, we are not drawing here
                ; dx = LINES_TO_GO
                ; bp = X_adjustESS (for data)

        cmp   ax, bx                            ;
        ja    CR_CT_gr                          ;
        je    CR_CT_eq                          ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CR_CT_a1                          ;#
        inc   si                                ;#
        inc   si                                ;#

CR_CT_a1:                                       ;#
        sub   bx, ax                            ; adjust tran count
        inc   si                                ;#
        inc   si                                ;#
        LODSB                                   ; get data count
        jmp SHORT   CR_CLIP_DATA                ; more clipping to do

CR_CT_eq:                                       ;
        cmp   ch, al                            ;# Is this the first trans data ?
        jne   CR_CT_b1                          ;#
        inc   si                                ;#
        inc   si                                ;#
CR_CT_b1:                                       ;#
        inc   si                                ;#
        inc   si                                ;#
        LODSB                                   ;
        mov   bx, [cs:X_LENGTH]                 ; # of bits to draw
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh
        or    di, dx
        jmp   CR_DRAW_DATA                      ; DATA MODE/DRAW

CR_CT_gr:                                       ;
        cmp   ch, al                            ;# first trans bits drawn ?
        jne   CR_CT_c1                          ;#
        inc   si                                ;#
        inc   si                                ;#
CR_CT_c1:                                       ;#
        sub   ax, bx                            ; dec trans bit count
        mov   bx, [cs:X_LENGTH]                 ; new draw count
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        jmp   CR_DRAW_TRANS                     ;

CR_CLIP_DATA:
                ; ah = 0
                ; bx = clip length remaining
                ; ax = # of data bits remaining
                ; ds:si --> transparent count
                ; es:di --> doesn't matter, we are not drawing here
                ; dx = LINES_TO_GO
                ; bp = X_adjust (for data)

        cmp   ax, bx                            ; # data bits input stream, # bits to clip
        ja    CR_CD_gr                          ; more data bits in input stream
        je    CR_CD_eq                          ; data bits input stream = clip bits
        sub   bx, ax                            ; decriment clip bits remaining
        add   si, ax                            ; point past data
        LODSB                                   ; load transparent count
        mov   ch, al                            ;#
        jmp   CR_CLIP_TRANS                     ; go to clipping trans mode

CR_CD_eq:                                       ;
        add   si, ax                            ; point past clipped data
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        LODSB                                   ; get transparent length
        mov   ch, al                            ;#
        mov   bx, [cs:X_LENGTH]                 ; reset # of bits to draw
        jmp   CR_DRAW_TRANS                     ; switch to trans mode, now drawing

CR_CD_gr:                                       ;
        add   si, bx                            ; point past clipped data
        sub   ax, bx                            ; more data in input stream
        inc   bp                                ;#
        inc   bp                                ;#
        mov   di, [cs:LineSt+bp]                ;#
        mov   dx, [cs:WrapSt+bp]                ;#
        add   di, [cs:LINE_ADDR]                ;#
        and   di, 1fffh                         ;#
        or    di, dx                            ;#
        mov   bx, [cs:X_LENGTH]                 ; reset # of bits to draw
        jmp   CR_DRAW_DATA                      ; still in data mode, now drawing

ENDP DRAW_SPRITEx


;=====================================================================
;**
;** TGA_DrawShape
;**
;** PURPOSE
;**	Draw a Shape on an TGA screen.
;**
;** INPUT
;**	DS:SI	far pointer to Shape data.
;**	BX	xpos.
;**	CX	ypos.
;**
;** REGISTER USED
;**	All of them
;**
;** EFFECTS
;**	??
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	May have problems if Shape Data crosses the end of the
;**	specified SEGMENT, so, NORMALIZE DS:SI so that SI is a
;**	small value (0-15).
;**
;** HISTORY
;**	
;**

	MPROC	TGA_DrawShape
	CALL	DRAW_SPRITE1
	or	bx,bx
	jz	@@cliped
	CALL	DRAW_SPRITE2
@@cliped:
	ret
	ENDP

;=====================================================================
;**
;** _TGA_DrawShape
;**
;** PURPOSE
;**	C glue for DrawShape.  Draws a shape on an TGA screen.
;**
;** INPUT
;**	C style parms: DrawShape (far *Shape, int x, int y)
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	NONE
;**
;** LIMITS/BUGS
;**	May have problems if Shape Data crosses the end of the
;**	specified SEGMENT, so, NORMALIZE DS:SI so that SI is a
;**	small value (0-15).
;**
;** HISTORY
;**	
;**

	MPROC _TGA_DrawShape
	ARG	SpOff:WORD,SpSeg:WORD,XPOS:WORD,YPOS:WORD

	push	bp
	mov	bp,sp

	push	ds
	push	si
	push	di

	mov	ds,[SpSeg]
	mov	si,[SpOff]
	mov	bx,[XPOS]
	mov	cx,[YPOS]
	mov	ax,bx	; get pixel (0-1) position and
	and	ax,001h	; choose correct shape.
	shl	ax,1
	shl	ax,1
	add	si,ax
;	mov	ax,[ds:si+8+2]	; get segment
;	mov	si,[ds:si+8]	; get offset
	mov	ax,[ds:si+8+2+2]	; get segment. 8+2 == GSHAPESIZE +
			;  transparent color pattern fields
	mov	si,[ds:si+8+2]	; get offset
	mov	ds,ax
	and	bx,0FFFEh	; truncate to byte boundry.

	call	TGA_DrawShape

	pop	di
	pop	si
	pop	ds

	pop	bp
	ret
	ENDP

;=====================================================================
;**
;** _TGA_SetClipArea
;**
;** PURPOSE
;**	C glue for SetClipArea.  Sets clipping variables.
;**
;** INPUT
;**	C style parms: SetClipArea (
;**						short xmin, short ymin,
;**						short xmax, short ymax
;**					)
;**
;** REGISTER USED
;**
;** EFFECTS
;**
;** RETURN VALUE
;**		NONE
;**
;** HISTORY
;**	
;**
	MPROC _TGA_SetClipArea

	ARG	XMIN:WORD,YMIN:WORD,XMAX:WORD,YMAX:WORD

	push	bp
	mov	bp,sp

	mov	ax,[XMIN]
	mov [CS:CLIP_LEFT],ax

	mov	ax,[YMIN]
	mov [CS:CLIP_TOP],ax

	mov	ax,[XMAX]
	mov [CS:CLIP_RIGHT],ax

	mov	ax,[YMAX]
	mov [CS:CLIP_BOTTOM],ax

	pop	bp
	ret
	ENDP

