;* 
;* The contents of this file are subject to the Mozilla Public 
;* License Version 1.1 (the "License"); you may not use this file 
;* except in compliance with the License. You may obtain a copy of 
;* the License at http://www.mozilla.org/MPL/ 
;* 
;* Software distributed under the License is distributed on an "AS 
;* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
;* implied. See the License for the specific language governing 
;* rights and limitations under the License. 
;* 
;* The Original Code is tUME: the Universal Map Editor, released 
;* June 18, 2000. 
;* 
;* The Initial Developer of the Original Code is Echidna. 
;* Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
;* All Rights Reserved. 
;* 
;* Contributor(s): 
;* 

;**
;** IBMERR.ASM
;**
;** PROGRAMMER : Gregg A. Tavares
;**    VERSION : 00.000
;**    CREATED : 04/28/90
;**   MODIFIED : 09/10/92
;**       TABS : 10 18 40 44
;**
;**	     \|///-_
;**	     \oo///_
;**	-----w/-w------
;**	 E C H I D N A
;**	---------------
;**
;** DESCRIPTION
;**	IBM Critical Error Header?
;**
;** HISTORY
;**
;**


	IDEAL

	INCLUDE "ERRMODEL.inc"

;**************************** GLOBAL VARIABLES *****************************
	PUBLIC _ErrReturnCode
	PUBLIC _SysErrorFunc
	PUBLIC _IgnoreErrors

;******************************** ROUTINES *********************************
	PUBLIC _IBMErrIntHeader

	CODESEG

_ErrReturnCode	DW ?
_SysErrorFunc	DD ?

;=====================================================================
;**
;** _IBMErrIntHeader
;**
;** PURPOSE
;**	
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**

	PROC _IBMErrIntHeader FAR
	
	push	bx	; save registers
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	push	ds
	push	es

	sti

	mov	ax,seg _SysErrorFunc
	mov	es,ax
	call	[dword ptr (es:_SysErrorFunc)]

	mov	ax,[CS:_ErrReturnCode]

	pop	es
	pop	ds
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx

	iret

	ENDP

;=====================================================================
;**
;** _IgnoreErrors
;**
;** PURPOSE
;**	Interrupt stub to "fail" dos errors.
;**
;** INPUT
;**	
;**
;** REGISTER USED
;**	
;**
;** EFFECTS
;**	
;**
;** RETURN VALUE
;**	
;**
;** LIMITS/BUGS
;**	
;**
;** HISTORY
;**	
;**
	PROC	_IgnoreErrors

	mov	ax,0
	mov	[CS:_ErrReturnCode],ax
	ret

	ENDP

	END

