/* 
 * The contents of this file are subject to the Mozilla Public 
 * License Version 1.1 (the "License"); you may not use this file 
 * except in compliance with the License. You may obtain a copy of 
 * the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS 
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * rights and limitations under the License. 
 * 
 * The Original Code is tUME: the Universal Map Editor, released 
 * June 18, 2000. 
 * 
 * The Initial Developer of the Original Code is Echidna. 
 * Portions created by Echidna are Copyright (c) 1989-2000 Echidna. 
 * All Rights Reserved. 
 * 
 * Contributor(s): 
 */

/*
 * VBLANK.H
 *
 * PROGRAMMER : Dan Chang
 *    VERSION : 00.000
 *    CREATED : 07/27/94
 *   MODIFIED : 07/27/94
 *       TABS : 04 07
 *
 * DESCRIPTION
 *		
 *
 * HISTORY
 *		07/27/94 Wednesday (dcc) - created.
 *
*/

#ifndef VBLANK_H
#define VBLANK_H

/**************************** C O N S T A N T S ***************************/

#define MAXVBLANKS 8

/* MAXTIMERRECORDS can't be larger than 2340 (== 32767 / sizeof(TimerType)) */
/* 32767 because functions return an integer handle. Sheesh. */

#define MAXTIMERRECORDS 256

/******************************** T Y P E S *******************************/

/* Ugliness in structure is for this reason: Trigger is only a three
	byte quantity. The fourth byte is used to store the flags.
	When you refer to ulTrigger, it will affect all four bytes.
	When you refer to ubFlags, it only affects the last byte. */

#if __MSDOS__
typedef struct			/* byte sex low byte to high byte */
{
	UWORD uwNext;		/* offset of next TimerRecord in linked list */
	UWORD uwPrev;		/* offset of previous TimerRecord in linked list */
	ULONG ulAddress;	/* address to call or increment */
	ULONG ulCounter;	/* passing time gets added here */
	union
	{
		ULONG Trigger;	/* ulCounter >= ulTrigger, do something */
		struct
		{
			UBYTE z[3];
			UBYTE Flags;
		} f;
	} u;
} TimerType;
#define ulTrigger u.Trigger
#define ubFlags u.f.Flags
#elif __AMIGAOS__
typedef struct			/* byte sex high byte to low byte */
{
	UWORD uwNext;		/* offset of next TimerRecord in linked list */
	UWORD uwPrev;		/* offset of previous TimerRecord in linked list */
	ULONG ulAddress;	/* address to call or increment */
	ULONG ulCounter;	/* passing time gets added here */
	union
	{
		ULONG Trigger;	/* ulCounter >= ulTrigger, do something */
		struct
		{
			UBYTE Flags;
			UBYTE z[3];
		} f;
	} u;
} TimerType;
#define ulTrigger u.Trigger
#define ubFlags u.f.Flags
#else
#error Need to determine byte sex of UNION
#endif

/****************************** G L O B A L S *****************************/

extern TimerType far32 _TimerRecord[MAXTIMERRECORDS];

extern void far32 * far32 _VBlankAddress[MAXVBLANKS];
extern BYTE far32 _VBlankActive[MAXVBLANKS];
extern WORD _LastVBlankActive;

#if __MSDOS__
extern void far32 _OpenTimerInterrupt(void);
extern void far32 _CloseTimerInterrupt(void);

extern UWORD far32 _uwFreeHead;	/* offset of first free timer record */

extern UWORD far32 _TimerCount;
extern UWORD far32 _NewTimerCount;
#endif/*__MSDOS__*/

#endif /* VBLANK_H */

